package middleware

import (
	"fmt"
	"github.com/gin-gonic/gin"
	"iot_manager_service/util"
	"net/http"
	"strings"
)

func CheckAuth() gin.HandlerFunc {
	return func(ctx *gin.Context) {
		//该路由下不校验token
		if strings.Contains(ctx.Request.RequestURI, "/login") ||
			strings.Contains(ctx.Request.RequestURI, "/captcha") ||
			strings.Contains(ctx.Request.RequestURI, "/tenant/info") ||
			strings.Contains(ctx.Request.RequestURI, "/token") {
			ctx.Next()
			return
		}

		authorization := ctx.GetHeader(Authorization)
		fmt.Printf("CheckAuth authorization = %s \n", authorization)
		if authorization != "" {
			token := parseAccessToken(authorization)
			if token != nil {
				ctx.Set(Authorization, token)
				ctx.Next()
				fmt.Printf("CheckAuth next \n")
				return
			}
		}
		ctx.JSON(http.StatusUnauthorized, util.NormalResponse(http.StatusUnauthorized, "token is invalid", nil))
		ctx.Abort()
	}
}
